--- old/usr/src/Targetdirs	2014-05-04 03:04:40.913253574 +0200
+++ new/usr/src/Targetdirs	2014-05-04 03:04:40.985918774 +0200
@@ -22,6 +22,7 @@
 # Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2011, Richard Lowe
 # Copyright (c) 2012 by Delphix. All rights reserved.
+# Copyright (c) 2012, Igor Kozhukhov <ikozhukhov@gmail.com>
 # Copyright 2012 OmniTI Computer Consulting, Inc.  All rights reserved.
 # Copyright (c) 2013 RackTop Systems.
 # Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
@@ -361,10 +362,12 @@
 	/usr/share/man/man3ldap \
 	/usr/share/man/man3lgrp \
 	/usr/share/man/man3lib \
+	/usr/share/man/man3m \
 	/usr/share/man/man3mail \
 	/usr/share/man/man3malloc \
 	/usr/share/man/man3mp \
 	/usr/share/man/man3mpapi \
+	/usr/share/man/man3mvec \
 	/usr/share/man/man3nsl \
 	/usr/share/man/man3nvpair \
 	/usr/share/man/man3pam \
--- old/usr/src/lib/Makefile	2014-05-04 03:04:43.473222243 +0200
+++ new/usr/src/lib/Makefile	2014-05-04 03:04:43.504265445 +0200
@@ -154,7 +154,11 @@
 	librdc		\
 	libinstzones	\
 	libpkg		\
-	libpcidb
+	libpcidb	\
+	libm1		\
+	libm		\
+	libmvec
+
 
 SUBDIRS += \
 	passwdutil	\
@@ -640,7 +644,7 @@
 print:		libldap5
 udapl/udapl_tavor:	udapl/libdat
 libzfs:		libdevid libgen libnvpair libuutil \
-		libadm libavl libefi libidmap libmd libzfs_core libm
+		libadm libavl libefi libidmap libmd libm libzfs_core
 libzfs_core:	libnvpair
 libzfs_jni:	libdiskmgt libnvpair libzfs
 libzpool:	libavl libumem libnvpair libcmdutils
--- old/usr/src/lib/libm/Makefile.com	2014-05-04 03:04:45.191907677 +0200
+++ new/usr/src/lib/libm/Makefile.com	2014-05-04 03:04:45.222294169 +0200
@@ -511,6 +511,10 @@
 LINTFLAGS64	+= $(LINTERROFF)
 LINTFLAGS64	+= -errchk=longptr64
 
+CERRWARN	+= -_gcc=-Wno-switch
+CERRWARN	+= -_gcc=-Wno-parentheses
+CERRWARN	+= -_gcc=-Wno-unused-variable
+
 CPPFLAGS	+= -DLIBM_BUILD
 
 CFLAGS 		+= $(C_BIGPICFLAGS)
--- old/usr/src/lib/libm/Makefile.libm.com	2014-05-04 03:04:46.997806072 +0200
+++ new/usr/src/lib/libm/Makefile.libm.com	2014-05-04 03:04:47.029373589 +0200
@@ -43,10 +43,8 @@
 CFLAGS64	+= $(C_PICFLAGS) -D__INLINE $(XSTRCONST) $(LM_IL)
 sparc_CFLAGS	+= -Wa,-xarch=v8plus
 
-CDEF_i386	= -DCOMPARISON_MACRO_BUG
 CPPFLAGS	+= -DELFOBJ \
 		-DLIBM_MT_FEX_SYNC \
-		$(CDEF_$(TARGET_ARCH)) \
 		-I$(LIBMSRC)/C \
 		-I$(LIBMSRC)/$(LDBLDIR) -I$(LIBMDIR)/$(TARGET_ARCH)/src
 
--- old/usr/src/lib/libm/Makefile.com	2014-05-04 03:04:48.960324737 +0200
+++ new/usr/src/lib/libm/Makefile.com	2014-05-04 03:04:48.988580570 +0200
@@ -511,6 +511,10 @@
 LINTFLAGS64	+= $(LINTERROFF)
 LINTFLAGS64	+= -errchk=longptr64
 
+CERRWARN	+= -_gcc=-Wno-switch
+CERRWARN	+= -_gcc=-Wno-parentheses
+CERRWARN	+= -_gcc=-Wno-unused-variable
+
 CPPFLAGS	+= -DLIBM_BUILD
 
 CFLAGS 		+= $(C_BIGPICFLAGS)
--- old/usr/src/lib/libm/Makefile.libm.com	2014-05-04 03:04:50.305625023 +0200
+++ new/usr/src/lib/libm/Makefile.libm.com	2014-05-04 03:04:50.336488674 +0200
@@ -43,10 +43,8 @@
 CFLAGS64	+= $(C_PICFLAGS) -D__INLINE $(XSTRCONST) $(LM_IL)
 sparc_CFLAGS	+= -Wa,-xarch=v8plus
 
-CDEF_i386	= -DCOMPARISON_MACRO_BUG
 CPPFLAGS	+= -DELFOBJ \
 		-DLIBM_MT_FEX_SYNC \
-		$(CDEF_$(TARGET_ARCH)) \
 		-I$(LIBMSRC)/C \
 		-I$(LIBMSRC)/$(LDBLDIR) -I$(LIBMDIR)/$(TARGET_ARCH)/src
 
--- old/usr/src/lib/libm/amd64/src/ieee_funcl.s	2014-05-04 03:04:51.715825955 +0200
+++ new/usr/src/lib/libm/amd64/src/ieee_funcl.s	2014-05-04 03:04:51.745227595 +0200
@@ -61,8 +61,7 @@
 					/      iff (msb(sgnfcnd(x) /= 0 
 					/	    &  0 < bexp(x) < 0x7fff)
 	movl	12(%rsp),%eax		/ eax <-- hi_32(sgnfcnd(x))
-	movq	$0x80000000,%r8
-	andq	%r8,%rax		/ eax[31]  <-- msb(sgnfcnd(x)),
+	andl	$-0x80000000,%eax	/ eax[31]  <-- msb(sgnfcnd(x)),
 					/ rest_of(eax) <-- 0
 	jz	.L8			/ jump iff msb(sgnfcnd(x)) = 0
 	movl	16(%rsp),%eax		/ ax <-- sign and bexp of x
@@ -82,7 +81,7 @@
 					/ msb(sgnfcnd(x)) = 0 & frac(x) /= 0)
 	movl	12(%rsp),%eax		/ eax <-- hi_32(sgnfcnd(x))
 	testl	$0x80000000,%eax	/ eax[31] = msb(sgnfcnd(x));
-					/ set ZF if it is 0.
+					/ set ZF if it's 0.
 	jz	.may_be_subnorm		/ jump iff msb(sgnfcnd(x)) = 0
 .not_subnorm:
 	movq	$0,%rax
--- old/usr/src/lib/libm/amd64/src/libm_inlines.h	2014-05-04 03:04:53.233984216 +0200
+++ new/usr/src/lib/libm/amd64/src/libm_inlines.h	2014-05-04 03:04:53.263587766 +0200
@@ -31,7 +31,7 @@
  * Copyright 2011, Richard Lowe.
  */
 
-/* Functions in this file are duplicated in libm.m4.  Keep them in sync */
+/* Functions in this file are duplicated in locallibm.il.  Keep them in sync */
 
 #ifndef _LIBM_INLINES_H
 #define	_LIBM_INLINES_H
@@ -45,15 +45,6 @@
 #include <sys/types.h>
 #include <sys/ieeefp.h>
 
-extern __inline__ double
-__ieee754_sqrt(double a)
-{
-	double ret;
-
-	__asm__ __volatile__("sqrtsd %1, %0\n\t" : "=x" (ret) : "x" (a));
-	return (ret);
-}
-
 extern __inline__ float
 __inline_sqrtf(float a)
 {
@@ -72,14 +63,10 @@
 	return (ret);
 }
 
-/* XXX: Not actually called */
-extern __inline__ short
-__inline_fstsw(void)
+extern __inline__ double
+__ieee754_sqrt(double a)
 {
-	short ret;
-
-	__asm__ __volatile__("fstsw %0\n\t" : "=r" (ret));
-	return (ret);
+	return (__inline_sqrt(a));
 }
 
 /*
@@ -131,150 +118,98 @@
 {
 	int ret;
 	__asm__ __volatile__(
-	    "movl    %1,%0\n\t"
+	    "movl    %1, %0\n\t"
 	    "negl    %1\n\t"
-	    "cmovnsl %1,%0\n\t"
-	    : "=r" (ret), "+r" (i));
+	    "cmovnsl %1, %0\n\t"
+	    : "=r" (ret), "+r" (i)
+	    :
+	    : "cc");
 	return (ret);
 }
 
 extern __inline__ double
 copysign(double d1, double d2)
 {
-	double ret;
+	double tmpd;
 
 	__asm__ __volatile__(
-	    "movq   $0x7fffffffffffffff,%%rax\n\t"
-	    "movd   %%rax,%%xmm2\n\t"
-	    "andpd  %%xmm2,%0\n\t"
-	    "andnpd %1,%%xmm2\n\t"
-	    "orpd   %%xmm2,%0\n\t"
-	    : "=x" (ret)
-	    : "x" (d2), "0" (d1)
-	    : "xmm2", "rax");
+	    "movd %3, %1\n\t"
+	    "andpd %1, %0\n\t"
+	    "andnpd %2, %1\n\t"
+	    "orpd %1, %0\n\t"
+	    : "+x" (d1), "=x" (tmpd)
+	    : "x" (d2), "r" (0x7fffffffffffffff));
 
-	return (ret);
-}
-
-extern __inline__ double
-d_sqrt_(double *d)
-{
-	double ret;
-	__asm__ __volatile__(
-	    "movlpd %1,%0\n\t"
-	    "sqrtsd %0,%0"
-	    : "=x" (ret)
-	    : "m" (*d));
-	return (ret);
+	return (d1);
 }
 
 extern __inline__ double
 fabs(double d)
 {
-	double ret;
+	double tmp;
 
 	__asm__ __volatile__(
-	    "movq  $0x7fffffffffffffff,%%rax\n\t"
-	    "movd  %%rax,%%xmm1\n\t"
-	    "andpd %%xmm1,%0"
-	    : "=x" (ret)
-	    : "0" (d)
-	    : "rax", "xmm1");
+	    "movd  %2, %1\n\t"
+	    "andpd %1, %0"
+	    : "+x" (d), "=x" (tmp)
+	    : "r" (0x7fffffffffffffff));
 
-	return (ret);
+	return (d);
 }
 
 extern __inline__ float
 fabsf(float d)
 {
-	float ret;
-
 	__asm__ __volatile__(
-	    "andpd %2,%0"
-	    : "=x" (ret)
-	    : "0" (d), "x" (0x7fffffff));
+	    "andpd %1, %0"
+	    : "+x" (d)
+	    : "x" (0x7fffffff));
 
-	return (ret);
+	return (d);
 }
 
 extern __inline__ int
 finite(double d)
 {
-	long ret;		    /* A long, so gcc chooses an %r* for %0 */
+    long ret = 0x7fffffffffffffff;
+	uint64_t tmp;
 
 	__asm__ __volatile__(
-	    "movq %1,%%rcx\n\t"
-	    "movq $0x7fffffffffffffff,%0\n\t"
-	    "andq %%rcx,%0\n\t"
-	    "movq $0x7ff0000000000000,%%rcx\n\t"
-	    "subq %%rcx,%0\n\t"
-	    "shrq $63,%0\n\t"
-	    : "=r" (ret)
+	    "movq %2, %1\n\t"
+	    "andq %1, %0\n\t"
+	    "movq $0x7ff0000000000000, %1\n\t"
+	    "subq %1, %0\n\t"
+	    "shrq $63, %0\n\t"
+	    : "+r" (ret), "=r" (tmp)
 	    : "x" (d)
-	    : "rcx");
+	    : "cc");
 
 	return (ret);
 }
 
-extern __inline__ float
-r_sqrt_(float *f)
-{
-	float ret;
-
-	__asm__ __volatile__(
-	    "movss  %1,%0\n\t"
-	    "sqrtss %0,%0\n\t"
-	    : "+x" (ret)
-	    : "m" (*f));
-	return (ret);
-}
-
 extern __inline__ int
 signbit(double d)
 {
 	long ret;
 	__asm__ __volatile__(
-	    "movmskpd %1,%0\n\t"
+	    "movmskpd %1, %0\n\t"
 	    "andq     $1, %0\n\t"
 	    : "=r" (ret)
-	    : "x" (d));
-	return (ret);
-}
-
-extern __inline__ int
-signbitf(float f)
-{
-	int ret;
-	__asm__ __volatile__(
-	    "movskps %1,%0\n\t"
-	    "andq    $1, %0\n\t"
-	    : "=r" (ret)
-	    : "x" (f));
+	    : "x" (d)
+	    : "cc");
 	return (ret);
 }
 
 extern __inline__ double
 sqrt(double d)
 {
-	double ret;
-
-	__asm__ __volatile__(
-	    "sqrtsd %0, %0"
-	    : "=x" (ret)
-	    : "0" (d));
-	return (ret);
+	return (__inline_sqrt(d));
 }
 
 extern __inline__ float
 sqrtf(float f)
 {
-	float ret;
-
-	__asm__ __volatile__(
-	    "sqrtss %0, %0"
-	    : "=x" (ret)
-	    : "0" (f));
-	return (ret);
+	return (__inline_sqrtf(f));
 }
 
 #ifdef __cplusplus
--- old/usr/src/lib/libm/amd64/src/locallibm.il	2014-05-04 03:04:54.975409335 +0200
+++ new/usr/src/lib/libm/amd64/src/locallibm.il	2014-05-04 03:04:55.004141867 +0200
@@ -40,10 +40,6 @@
 	sqrtsd	%xmm0,%xmm0
 	.end
 
-	.inline	__inline_fstsw,0
-	fstsw	%ax
-	.end
-
 /
 / 00 - 24 bits
 / 01 - reserved
@@ -103,11 +99,6 @@
 	orpd	%xmm2,%xmm0
 	.end
 
-	.inline	__d_sqrt_,0
-	movlpd	(%rdi),%xmm0
-	sqrtsd	%xmm0,%xmm0
-	.end
-
 	.inline	__fabs,0
 	movq	$0x7fffffffffffffff,%rax
 	movdq	%rax,%xmm1
@@ -132,21 +123,11 @@
 	addq	$16,%rsp
 	.end
 
-	.inline	__r_sqrt_,0
-	movss	(%rdi),%xmm0
-	sqrtss	%xmm0,%xmm0
-	.end
-
 	.inline	__signbit,0
 	movmskpd %xmm0,%eax
 	andq	$1,%rax
 	.end
 
-	.inline	__signbitf,0
-	movmskps %xmm0,%eax
-	andq	$1,%rax
-	.end
-
 	.inline	__sqrt,0
 	sqrtsd	%xmm0,%xmm0
 	.end
--- old/usr/src/lib/libm/common/C/_SVID_error.c	2014-05-04 03:04:56.538293806 +0200
+++ new/usr/src/lib/libm/common/C/_SVID_error.c	2014-05-04 03:04:56.568154016 +0200
@@ -122,7 +122,7 @@
 double
 _SVID_libm_err(double x, double y, int type) {
 	struct exception	exc;
-	double			t, w, ieee_retval;
+	double			t, w, ieee_retval = 0;
 	enum version		lib_version = _lib_version;
 	int			iy;
 
@@ -856,11 +856,8 @@
 		if (lib_version == strict_ansi) {
 			exc.retval = 1.0;
 		} else if (!matherr(&exc)) {
-			switch (lib_version) {
-			case c_issue_4:
-			case ansi_1:
+			if ((lib_version == c_issue_4) || (lib_version == ansi_1))
 				errno = EDOM;
-			}
 		}
 		break;
 	case 43:
--- old/usr/src/lib/libm/common/C/__tan.c	2014-05-04 03:04:58.875277137 +0200
+++ new/usr/src/lib/libm/common/C/__tan.c	2014-05-04 03:04:58.897898162 +0200
@@ -121,14 +121,14 @@
 
 double
 __k_tan(double x, double y, int k) {
-	double a, t, z, w, s, c, r, rh, xh, xl;
+	double a, t, z, w = 0.0L, s, c, r, rh, xh, xl;
 	int i, j, hx, ix;
 
 	t = one;
 	hx = ((int *) &x)[HIWORD];
 	ix = hx & 0x7fffffff;
-	if (ix < 0x3fc40000) {
-		if (ix < 0x3e400000) {
+	if (ix < 0x3fc40000) {		/* 0.15625 */
+		if (ix < 0x3e400000) {	/* 2^-27 */
 			if ((i = (int) x) == 0)		/* generate inexact */
 				w = x;
 			t = y;
--- old/usr/src/lib/libm/common/C/asin.c	2014-05-04 03:05:00.172312075 +0200
+++ new/usr/src/lib/libm/common/C/asin.c	2014-05-04 03:05:00.202234953 +0200
@@ -105,7 +105,7 @@
 double
 asin(double x) {
 	double t, w, p, q, c, r, s;
-	int hx, ix;
+	int hx, ix, i;
 
 	hx = ((int *) &x)[HIWORD];
 	ix = hx & 0x7fffffff;
@@ -125,12 +125,11 @@
 	}
 	else if (ix < 0x3fe00000) {	/* |x| < 0.5 */
 		if (ix < 0x3e400000) {	/* if |x| < 2**-27 */
-			if (huge + x > one)
+			if ((i = (int) x) == 0)
 				return x;	/* return x with inexact if
 						 * x != 0 */
 		}
-		else
-			t = x * x;
+		t = x * x;
 		p = t * (pS0 + t * (pS1 + t * (pS2 + t * (pS3 +
 			t * (pS4 + t * pS5)))));
 		q = one + t * (qS1 + t * (qS2 + t * (qS3 + t * qS4)));
--- old/usr/src/lib/libm/common/C/expm1.c	2014-05-04 03:05:02.531093433 +0200
+++ new/usr/src/lib/libm/common/C/expm1.c	2014-05-04 03:05:02.346727765 +0200
@@ -160,7 +160,7 @@
 
 double
 expm1(double x) {
-	double y, hi, lo, c, t, e, hxs, hfx, r1;
+	double y, hi, lo, c = 0.0L, t, e, hxs, hfx, r1;
 	int k, xsb;
 	unsigned hx;
 
@@ -172,9 +172,10 @@
 		y = -x;				/* y = |x| */
 	hx &= 0x7fffffff;			/* high word of |x| */
 
-	/* filter out huge and non-finite arugment */
-	if (hx >= 0x4043687A) {			/* if |x|>=56*ln2 */
-		if (hx >= 0x40862E42) {		/* if |x|>=709.78... */
+	/* filter out huge and non-finite argument */
+	/* for example exp(38)-1 is approximately 3.1855932e+16 */
+	if (hx >= 0x4043687A) {			/* if |x|>=56*ln2  (~38.8162...)*/
+		if (hx >= 0x40862E42) {		/* if |x|>=709.78... -> inf */
 			if (hx >= 0x7ff00000) {
 				if (((hx & 0xfffff) | ((int *) &x)[LOWORD])
 					!= 0)
@@ -194,31 +195,31 @@
 	/* argument reduction */
 	if (hx > 0x3fd62e42) {			/* if  |x| > 0.5 ln2 */
 		if (hx < 0x3FF0A2B2) {		/* and |x| < 1.5 ln2 */
-			if (xsb == 0) {
+			if (xsb == 0) {		/* positive number */
 				hi = x - ln2_hi;
 				lo = ln2_lo;
 				k = 1;
 			}
-			else {
+			else { /* negative number */
 				hi = x + ln2_hi;
 				lo = -ln2_lo;
 				k = -1;
 			}
 		}
-		else {
+		else {	/* |x| > 1.5 ln2 */
 			k = (int) (invln2 * x + (xsb == 0 ? 0.5 : -0.5));
 			t = k;
 			hi = x - t * ln2_hi;	/* t*ln2_hi is exact here */
 			lo = t * ln2_lo;
 		}
 		x = hi - lo;
-		c = (hi - x) - lo;
+		c = (hi - x) - lo; /* still at |x| > 0.5 ln2 */
 	}
 	else if (hx < 0x3c900000) {		/* when |x|<2**-54, return x */
 		t = huge + x;		/* return x w/inexact when x != 0 */
 		return x - (t - (huge + x));
 	}
-	else
+	else	/* |x| <= 0.5 ln2 */
 		k = 0;
 
 	/* x is now in primary range */
@@ -227,18 +228,19 @@
 	r1 = one + hxs * (Q1 + hxs * (Q2 + hxs * (Q3 + hxs * (Q4 + hxs * Q5))));
 	t = 3.0 - r1 * hfx;
 	e = hxs * ((r1 - t) / (6.0 - x * t));
-	if (k == 0)
-		return x - (x * e - hxs);	/* c is 0 */
-	else {
+	if (k == 0) /* |x| <= 0.5 ln2 */
+		return x - (x * e - hxs);
+	else {      /* |x| > 0.5 ln2 */
 		e = (x * (e - c) - c);
 		e -= hxs;
 		if (k == -1)
 			return 0.5 * (x - e) - 0.5;
-		if (k == 1)
+		if (k == 1) {
 			if (x < -0.25)
 				return -2.0 * (e - (x + 0.5));
 			else
 				return one + 2.0 * (x - e);
+		}
 		if (k <= -2 || k > 56) {	/* suffice to return exp(x)-1 */
 			y = one - (e - x);
 			((int *) &y)[HIWORD] += k << 20;
--- old/usr/src/lib/libm/common/C/jn.c	2014-05-04 03:05:04.062282644 +0200
+++ new/usr/src/lib/libm/common/C/jn.c	2014-05-04 03:05:04.092027863 +0200
@@ -71,7 +71,7 @@
 GENERIC
 jn(int n, GENERIC x) {
 	int i, sgn;
-	GENERIC a, b, temp;
+	GENERIC a, b, temp = 0;
 	GENERIC z, w, ox, on;
 
     /* J(-n,x) = (-1)^n * J(n, x), J(n, -x) = (-1)^n * J(n, x)
@@ -217,17 +217,19 @@
 yn(int n, GENERIC x) {
 	int i;
 	int sign;
-	GENERIC a, b, temp, ox, on;
+	GENERIC a, b, temp = 0, ox, on;
 
 	ox = x; on = (GENERIC)n;
 	if(isnan(x)) return x*x;	/* + -> * for Cheetah */
-	if (x <= zero)
-		if(x==zero)
+	if (x <= zero) {
+		if(x==zero) {
 			/* return -one/zero; */
 			return _SVID_libm_err((GENERIC)n,x,12);
-		else
+		} else {
 			/* return zero/zero; */
 			return _SVID_libm_err((GENERIC)n,x,13);
+		}
+	}
 	if (!((int) _lib_version == libm_ieee ||
 		(__xpg6 & _C99SUSv3_math_errexcept) != 0)) {
 	    if(x > X_TLOSS) return _SVID_libm_err(on,ox,39);
--- old/usr/src/lib/libm/common/C/log1p.c	2014-05-04 03:05:06.009967960 +0200
+++ new/usr/src/lib/libm/common/C/log1p.c	2014-05-04 03:05:06.246615699 +0200
@@ -123,7 +123,7 @@
 
 double
 log1p(double x) {
-	double	hfsq, f, c, s, z, R, u;
+	double	hfsq, f, c = 0.0, s, z, R, u;
 	int	k, hx, hu, ax;
 
 	hx = ((int *)&x)[HIWORD];		/* high word of x */
@@ -152,6 +152,7 @@
 			hu = 1;
 		}
 	}
+	/* We will initialize 'c' here. */
 	if (k != 0) {
 		if (hx < 0x43400000) {
 			u = 1.0 + x;
@@ -183,6 +184,7 @@
 		if (f == zero) {
 			if (k == 0)
 				return (zero);
+			/* We already initialized 'c' before, when (k != 0) */
 			c += k * ln2_lo;
 			return (k * ln2_hi + c);
 		}
--- old/usr/src/lib/libm/common/C/nextafter.c	2014-05-04 03:05:07.378100063 +0200
+++ new/usr/src/lib/libm/common/C/nextafter.c	2014-05-04 03:05:07.404742713 +0200
@@ -37,6 +37,7 @@
 	int		hx, hy, k;
 	double		ans;
 	unsigned	lx;
+	volatile double dummy;
 
 	hx = ((int *)&x)[HIWORD];
 	lx = ((int *)&x)[LOWORD];
@@ -79,7 +80,7 @@
 #if !defined(__lint)
 	} else if (k == 0) {
 		/* underflow */
-		volatile double dummy = DBL_MIN * copysign(DBL_MIN, x);
+		dummy = DBL_MIN * copysign(DBL_MIN, x);
 #endif
 	}
 	return (ans);
--- old/usr/src/lib/libm/common/C/pow.c	2014-05-04 03:05:08.683384811 +0200
+++ new/usr/src/lib/libm/common/C/pow.c	2014-05-04 03:05:08.712766793 +0200
@@ -248,8 +248,8 @@
 			if (ahx >= 0x5ff00000 && ahx < 0x7ff00000)
 				return (_SVID_libm_err(x, y, 21));
 							/* x*x overflow */
-			else if (ahx < 0x1e56a09e && (ahx | lx) != 0 ||
-				ahx == 0x1e56a09e && lx < 0x667f3bcd)
+			else if ((ahx < 0x1e56a09e && (ahx | lx) != 0) ||
+				(ahx == 0x1e56a09e && lx < 0x667f3bcd))
 				return (_SVID_libm_err(x, y, 22));
 							/* x*x underflow */
 			else
--- old/usr/src/lib/libm/common/LD/__cosl.c	2014-05-04 03:05:10.604051546 +0200
+++ new/usr/src/lib/libm/common/LD/__cosl.c	2014-05-04 03:05:10.847762698 +0200
@@ -106,10 +106,10 @@
 	int i, j, hx, ix;
 
 	t = 1.0;
-#if defined(_BIG_ENDIAN)
-	hx = px[0];
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, hx);
+#else
+	hx = px[0];
 #endif
 	ix = hx & 0x7fffffff;
 	if (ix < 0x3ffc4000) {
@@ -127,10 +127,10 @@
 	}
 	j = (ix + 0x400) & 0x7ffff800;
 	i = (j - 0x3ffc4000) >> 11;
-#if defined(_BIG_ENDIAN)
-	pt[0] = j;
-#else
+#if defined(__i386) || defined(__amd64)
 	ITOX(j, pt);
+#else
+	pt[0] = j;
 #endif
 	if (hx > 0)
 		x = y - (t - x);
--- old/usr/src/lib/libm/common/LD/__rem_pio2l.c	2014-05-04 03:05:12.579770612 +0200
+++ new/usr/src/lib/libm/common/LD/__rem_pio2l.c	2014-05-04 03:05:12.609295362 +0200
@@ -34,6 +34,7 @@
  */
 
 #include "libm.h"
+#include "longdouble.h"
 
 extern const int _TBL_ipio2l_inf[];
 
--- old/usr/src/lib/libm/common/LD/__sincosl.c	2014-05-04 03:05:14.305532492 +0200
+++ new/usr/src/lib/libm/common/LD/__sincosl.c	2014-05-04 03:05:14.337053144 +0200
@@ -97,10 +97,10 @@
 	int i, j, hx, ix;
 
 	t = 1.0;
-#if defined(_BIG_ENDIAN)
-	hx = px[0];
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, hx);
+#else
+	hx = px[0];
 #endif
 	ix = hx & 0x7fffffff;
 	if (ix < 0x3ffc4000) {
@@ -128,10 +128,10 @@
 	}
 	j = (ix + 0x400) & 0x7ffff800;
 	i = (j - 0x3ffc4000) >> 11;
-#if defined(_BIG_ENDIAN)
-	pt[0] = j;
-#else
+#if defined(__i386) || defined(__amd64)
 	ITOX(j, pt);
+#else
+	pt[0] = j;
 #endif
 	if (hx > 0)
 		x = y - (t - x);
--- old/usr/src/lib/libm/common/LD/__sinl.c	2014-05-04 03:05:15.828418817 +0200
+++ new/usr/src/lib/libm/common/LD/__sinl.c	2014-05-04 03:05:15.858994406 +0200
@@ -107,10 +107,10 @@
 	int i, j, hx, ix;
 
 	t = 1.0L;
-#if defined(_BIG_ENDIAN)
-	hx = px[0];
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, hx);
+#else
+	hx = px[0];
 #endif
 	ix = hx & 0x7fffffff;
 	if (ix < 0x3ffc9000) {
@@ -125,10 +125,10 @@
 	}
 	j = (ix + 0x400) & 0x7ffff800;
 	i = (j - 0x3ffc4000) >> 11;
-#if defined(_BIG_ENDIAN)
-	pt[0] = j;
-#else
+#if defined(__i386) || defined(__amd64)
 	ITOX(j, pt);
+#else
+	pt[0] = j;
 #endif
 	if (hx > 0)
 		x = y - (t - x);
--- old/usr/src/lib/libm/common/LD/__tanl.c	2014-05-04 03:05:16.932573892 +0200
+++ new/usr/src/lib/libm/common/LD/__tanl.c	2014-05-04 03:05:17.176255223 +0200
@@ -111,15 +111,15 @@
 /* INDENT ON */
 long double
 __k_tanl(long double x, long double y, int k) {
-	long double a, t, z, w, s, c;
+	long double a, t, z, w = 0.0, s, c;
 	int *pt = (int *) &t, *px = (int *) &x;
 	int i, j, hx, ix;
 
 	t = 1.0;
-#if defined(_BIG_ENDIAN)
-	hx = px[0];
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, hx);
+#else
+	hx = px[0];
 #endif
 	ix = hx & 0x7fffffff;
 	if (ix < 0x3ffc4000) {
@@ -142,10 +142,10 @@
 	}
 	j = (ix + 0x400) & 0x7ffff800;
 	i = (j - 0x3ffc4000) >> 11;
-#if defined(_BIG_ENDIAN)
-	pt[0] = j;
-#else
+#if defined(__i386) || defined(__amd64)
 	ITOX(j, pt);
+#else
+	pt[0] = j;
 #endif
 	if (hx > 0)
 		x = y - (t - x);
--- old/usr/src/lib/libm/common/LD/asinhl.c	2014-05-04 03:05:18.657959429 +0200
+++ new/usr/src/lib/libm/common/LD/asinhl.c	2014-05-04 03:05:18.685017586 +0200
@@ -42,13 +42,14 @@
 long double
 asinhl(long double x) {
 	long double t, w;
+	volatile long double dummy;
 
 	w = fabsl(x);
 	if (isnanl(x))
 		return (x + x);	/* x is NaN */
 	if (w < tiny) {
 #ifndef lint
-		volatile long double dummy = x + big;	/* inexact if x != 0 */
+		dummy = x + big;	/* inexact if x != 0 */
 #endif
 		return (x);	/* tiny x */
 	} else if (w < big) {
--- old/usr/src/lib/libm/common/LD/cbrtl.c	2014-05-04 03:05:20.590001890 +0200
+++ new/usr/src/lib/libm/common/LD/cbrtl.c	2014-05-04 03:05:20.625255436 +0200
@@ -32,6 +32,7 @@
 #endif
 
 #include "libm.h"
+#include "longdouble.h"
 
 static const double d_one = 1.0;
 
--- old/usr/src/lib/libm/common/LD/coshl.c	2014-05-04 03:05:22.152826129 +0200
+++ new/usr/src/lib/libm/common/LD/coshl.c	2014-05-04 03:05:22.183031406 +0200
@@ -32,6 +32,7 @@
 #endif
 
 #include "libm.h"
+#include "longdouble.h"
 
 /*
  * COSH(X)
--- old/usr/src/lib/libm/common/LD/cosl.c	2014-05-04 03:05:24.316300765 +0200
+++ new/usr/src/lib/libm/common/LD/cosl.c	2014-05-04 03:05:24.346624215 +0200
@@ -79,10 +79,10 @@
 		return x - x;
 
 	/* High word of x. */
-#if defined(_BIG_ENDIAN)
-	ix = px[0];
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, ix);
+#else
+	ix = px[0];
 #endif
 
 	/* |x| ~< pi/4 */
--- old/usr/src/lib/libm/common/LD/isnanl.c	2014-05-04 03:05:25.458078191 +0200
+++ new/usr/src/lib/libm/common/LD/isnanl.c	2014-05-04 03:05:25.473885751 +0200
@@ -45,8 +45,8 @@
 isnanl(long double x) {
 	int *px = (int *) &x, t = px[2] & 0x7fff;
 #if defined(HANDLE_UNSUPPORTED)
-	return (t == 0x7fff && ((px[1] & ~0x80000000) | px[0]) != 0 ||
-		t != 0 && (px[1] & 0x80000000) == 0);
+	return ((t == 0x7fff && ((px[1] & ~0x80000000) | px[0]) != 0) ||
+		(t != 0 && (px[1] & 0x80000000) == 0));
 #else
 	return (t == 0x7fff && ((px[1] & ~0x80000000) | px[0]) != 0);
 #endif
--- old/usr/src/lib/libm/common/LD/j0l.c	2014-05-04 03:05:26.761068863 +0200
+++ new/usr/src/lib/libm/common/LD/j0l.c	2014-05-04 03:05:27.005059295 +0200
@@ -41,6 +41,9 @@
 
 #include "libm.h"
 #include "libm_synonyms.h"
+
+#include "longdouble.h"
+
 #include <math.h>
 #if defined(__SUNPRO_C)
 #include <sunmath.h>
--- old/usr/src/lib/libm/common/LD/j1l.c	2014-05-04 03:05:28.325281508 +0200
+++ new/usr/src/lib/libm/common/LD/j1l.c	2014-05-04 03:05:28.354209628 +0200
@@ -41,6 +41,7 @@
 
 #include "libm.h"
 #include "libm_synonyms.h"
+#include "longdouble.h"
 #include <math.h>
 #if defined(__SUNPRO_C)
 #include <sunmath.h>
--- old/usr/src/lib/libm/common/LD/jnl.c	2014-05-04 03:05:29.863215255 +0200
+++ new/usr/src/lib/libm/common/LD/jnl.c	2014-05-04 03:05:29.892904056 +0200
@@ -58,6 +58,7 @@
  */
 
 #include "libm.h"
+#include "longdouble.h"
 #include <float.h>	/* LDBL_MAX */
 
 #define GENERIC long double
@@ -71,7 +72,7 @@
 GENERIC
 jnl(n,x) int n; GENERIC x;{
 	int i, sgn;
-	GENERIC a, b, temp, z, w;
+	GENERIC a, b, temp = 0, z, w;
 
     /* J(-n,x) = (-1)^n * J(n, x), J(n, -x) = (-1)^n * J(n, x)
      * Thus, J(-n,x) = J(n,-x)
@@ -211,14 +212,16 @@
 int n; GENERIC x;{
 	int i;
 	int sign;
-	GENERIC a, b, temp;
+	GENERIC a, b, temp = 0;
 
-	if(x!=x) return x+x;
-	if (x <= zero) 
+	if(x!=x)
+		return x+x;
+	if (x <= zero) {
 		if(x==zero) 
 			return -one/zero;
 		else 
 			return zero/zero;
+	}
 	sign = 1;
 	if(n<0){
 		n = -n;
--- old/usr/src/lib/libm/common/LD/log1pl.c	2014-05-04 03:05:31.801047449 +0200
+++ new/usr/src/lib/libm/common/LD/log1pl.c	2014-05-04 03:05:31.618517331 +0200
@@ -54,11 +54,12 @@
 		return (logl(x));
 	rd = __swapRD(fp_nearest);
 	y = 1.L + x;
-	if (y != 1.L)
+	if (y != 1.L) {
 		if (y == x)
 			x = logl(x);
 		else
 			x *= logl(y) / (y - 1.L);
+	}
 	if (rd != fp_nearest)
 		(void) __swapRD(rd);
 	return (x);
--- old/usr/src/lib/libm/common/LD/scalbl.c	2014-05-04 03:05:33.350064276 +0200
+++ new/usr/src/lib/libm/common/LD/scalbl.c	2014-05-04 03:05:33.381190898 +0200
@@ -48,16 +48,16 @@
 
 	/* fn is +/-Inf */
 #if defined(_BIG_ENDIAN)
-	if ((py[0] & 0x7fff0000) == 0x7fff0000)
+	if ((py[0] & 0x7fff0000) == 0x7fff0000) {
 		if ((py[0] & 0x80000000) != 0)
 #else
-	if ((py[2] & 0x7fff) == 0x7fff)
+	if ((py[2] & 0x7fff) == 0x7fff) {
 		if ((py[2] & 0x8000) != 0)
 #endif
 			return x / (-fn);
 		else
 			return x * fn;
-
+	}
 	if (rintl(fn) != fn)
 		return (fn - fn) / (fn - fn);
 	if (fn > 65000.0L)
--- old/usr/src/lib/libm/common/LD/sincosl.c	2014-05-04 03:05:34.659120537 +0200
+++ new/usr/src/lib/libm/common/LD/sincosl.c	2014-05-04 03:05:34.689969082 +0200
@@ -71,7 +71,7 @@
 sincosl(long double x, long double *s, long double *c) {
 	long double y[2], z = 0.0L;
 	int n, ix;
-#if defined(_LITTLE_ENDIAN)
+#if defined(__i386) || defined(__amd64)
 	int *px = (int *) &x;
 #endif
 
@@ -82,10 +82,10 @@
 	}
 
 	/* High word of x. */
-#if defined(_BIG_ENDIAN)
-	ix = *(int *) &x;
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, ix);
+#else
+	ix = *(int *) &x;
 #endif
 
 	/* |x| ~< pi/4 */
--- old/usr/src/lib/libm/common/LD/sincospil.c	2014-05-04 03:05:36.157111133 +0200
+++ new/usr/src/lib/libm/common/LD/sincospil.c	2014-05-04 03:05:36.180806176 +0200
@@ -78,7 +78,7 @@
 
 #define I(q, m)	((int *) &(q))[m]
 #define U(q, m)	((unsigned *) &(q))[m]
-#if defined(_LITTLE_ENDIAN)
+#if defined(__i386) || defined(__amd64)
 #define LDBL_MOST_SIGNIF_I(ld)	((I(ld, 2) << 16) | (0xffff & (I(ld, 1) >> 15)))
 #define LDBL_LEAST_SIGNIF_U(ld)	U(ld, 0)
 #define PREC	64
--- old/usr/src/lib/libm/common/LD/sinhl.c	2014-05-04 03:05:37.517341221 +0200
+++ new/usr/src/lib/libm/common/LD/sinhl.c	2014-05-04 03:05:37.761477082 +0200
@@ -30,6 +30,7 @@
 #pragma weak sinhl = __sinhl
 
 #include "libm.h"
+#include "longdouble.h"
 
 /* SINH(X)
  * RETURN THE HYPERBOLIC SINE OF X
--- old/usr/src/lib/libm/common/LD/sinl.c	2014-05-04 03:05:38.821572304 +0200
+++ new/usr/src/lib/libm/common/LD/sinl.c	2014-05-04 03:05:38.851339792 +0200
@@ -72,7 +72,7 @@
 sinl(long double x) {
 	long double y[2], z = 0.0L;
 	int n, ix;
-#if defined(_LITTLE_ENDIAN)
+#if defined(__i386) || defined(__amd64)
 	int *px = (int *) &x;
 #endif
 
@@ -81,16 +81,15 @@
 		return x - x;
 
 	/* High word of x. */
-#if defined(_BIG_ENDIAN)
-	ix = *(int *) &x;
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, ix);
+#else
+	ix = *(int *) &x;
 #endif
 	/* |x| ~< pi/4 */
 	ix &= 0x7fffffff;
-	if (ix <= 0x3ffe9220) {
+	if (ix <= 0x3ffe9220)
 		return __k_sinl(x, z);
-        }
 
 	/* argument reduction needed */
 	else {
@@ -107,5 +106,5 @@
 		/* NOTREACHED */
 		}
 	}
-    return 0.0L;
+	return 0.0L;
 }
--- old/usr/src/lib/libm/common/LD/sinpil.c	2014-05-04 03:05:39.942975095 +0200
+++ new/usr/src/lib/libm/common/LD/sinpil.c	2014-05-04 03:05:39.955350802 +0200
@@ -77,7 +77,7 @@
 
 #define I(q, m)	((int *) &(q))[m]
 #define U(q, m)	((unsigned *) &(q))[m]
-#if defined(_LITTLE_ENDIAN)
+#if defined(__i386) || defined(__amd64)
 #define LDBL_MOST_SIGNIF_I(ld)	((I(ld, 2) << 16) | (0xffff & (I(ld, 1) >> 15)))
 #define LDBL_LEAST_SIGNIF_U(ld)	U(ld, 0)
 #define PREC	64
--- old/usr/src/lib/libm/common/LD/tanhl.c	2014-05-04 03:05:41.590737174 +0200
+++ new/usr/src/lib/libm/common/LD/tanhl.c	2014-05-04 03:05:41.620104634 +0200
@@ -60,6 +60,7 @@
  */
 
 #include "libm.h"
+#include "longdouble.h"
 
 static const long double small = 1.0e-20L, one = 1.0, two = 2.0,
 #ifndef lint
@@ -71,6 +72,7 @@
 tanhl(long double x) {
 	long double t, y, z;
 	int signx;
+	volatile long double dummy;
 
 	if (isnanl(x))
 		return (x + x);		/* x is NaN */
@@ -85,7 +87,7 @@
 			z = -y / (y + two);
 		} else {
 #ifndef lint
-			volatile long double dummy = t + big;
+			dummy = t + big;
 							/* inexact if t != 0 */
 #endif
 			return (x);
--- old/usr/src/lib/libm/common/LD/tanl.c	2014-05-04 03:05:43.975402675 +0200
+++ new/usr/src/lib/libm/common/LD/tanl.c	2014-05-04 03:05:44.003714702 +0200
@@ -71,7 +71,7 @@
 tanl(long double x) {
 	long double y[2], z = 0.0L;
 	int n, ix;
-#if defined(_LITTLE_ENDIAN)
+#if defined(__i386) || defined(__amd64)
 	int *px = (int *) &x;
 #endif
 
@@ -80,10 +80,10 @@
 		return x - x;
 
 	/* High word of x. */
-#if defined(_BIG_ENDIAN)
-	ix = *(int *) &x;
-#else
+#if defined(__i386) || defined(__amd64)
 	XTOI(px, ix);
+#else
+	ix = *(int *) &x;
 #endif
 
 	/* |x| ~< pi/4 */
--- old/usr/src/lib/libm/common/Q/__tanl.c	2014-05-04 03:05:46.338181476 +0200
+++ new/usr/src/lib/libm/common/Q/__tanl.c	2014-05-04 03:05:46.367610637 +0200
@@ -111,7 +111,7 @@
 
 long double
 __k_tanl(long double x, long double y, int k) {
-	long double a, t, z, w, s, c;
+	long double a, t, z, w = 0, s, c;
 	int *pt = (int *) &t, *px = (int *) &x;
 	int i, j, hx, ix;
 
--- old/usr/src/lib/libm/common/Q/asinhl.c	2014-05-04 03:05:47.693535487 +0200
+++ new/usr/src/lib/libm/common/Q/asinhl.c	2014-05-04 03:05:47.724160942 +0200
@@ -42,13 +42,14 @@
 long double
 asinhl(long double x) {
 	long double t, w;
+	volatile long double dummy;
 
 	w = fabsl(x);
 	if (isnanl(x))
 		return (x + x);	/* x is NaN */
 	if (w < tiny) {
 #ifndef lint
-		volatile long double dummy = x + big;	/* inexact if x != 0 */
+		dummy = x + big;	/* inexact if x != 0 */
 #endif
 		return (x);	/* tiny x */
 	} else if (w < big) {
--- old/usr/src/lib/libm/common/Q/asinl.c	2014-05-04 03:05:49.304364118 +0200
+++ new/usr/src/lib/libm/common/Q/asinl.c	2014-05-04 03:05:49.335469626 +0200
@@ -53,6 +53,7 @@
 long double
 asinl(long double x) {
 	long double t, w;
+	volatile long double dummy;
 
 	w = fabsl(x);
 	if (isnanl(x))
@@ -60,7 +61,7 @@
 	else if (w <= half) {
 		if (w < small) {
 #ifndef lint
-			volatile long double dummy = w + big;
+			dummy = w + big;
 							/* inexact if w != 0 */
 #endif
 			return (x);
--- old/usr/src/lib/libm/common/Q/atan2l.c	2014-05-04 03:05:50.769934893 +0200
+++ new/usr/src/lib/libm/common/Q/atan2l.c	2014-05-04 03:05:50.800350865 +0200
@@ -103,7 +103,7 @@
 		return (signy == 1 ? -PIo2 - tiny : PIo2 + tiny);
 
 	/* when x is INF */
-	if (!finitel(x))
+	if (!finitel(x)) {
 		if (!finitel(y)) {
 			switch (m) {
 			case 0:
@@ -127,7 +127,7 @@
 				return (-PI - tiny);	/* atan(-...,-INF) */
 			}
 		}
-
+	}
 	/* when y is INF */
 	if (!finitel(y))
 		return (signy == 1 ? -PIo2 - tiny : PIo2 + tiny);
--- old/usr/src/lib/libm/common/Q/jnl.c	2014-05-04 03:05:52.278360984 +0200
+++ new/usr/src/lib/libm/common/Q/jnl.c	2014-05-04 03:05:52.738327527 +0200
@@ -218,11 +218,12 @@
 	GENERIC a, b, temp;
 
 	if(x!=x) return x+x;
-	if (x <= zero)
+	if (x <= zero) {
 		if(x==zero)
 			return -one/zero;
 		else
 			return zero/zero;
+	}
 	sign = 1;
 	if(n<0){
 		n = -n;
--- old/usr/src/lib/libm/common/Q/tanhl.c	2014-05-04 03:05:53.792831608 +0200
+++ new/usr/src/lib/libm/common/Q/tanhl.c	2014-05-04 03:05:53.821946273 +0200
@@ -72,6 +72,7 @@
 tanhl(long double x) {
 	long double t, y, z;
 	int signx;
+	volatile long double dummy;
 
 	if (isnanl(x))
 		return (x + x);		/* x is NaN */
@@ -86,7 +87,7 @@
 			z = -y / (y + two);
 		} else {
 #ifndef lint
-			volatile long double dummy = t + big;
+			dummy = t + big;
 							/* inexact if t != 0 */
 #endif
 			return (x);
--- old/usr/src/lib/libm/common/R/__tanf.c	2014-05-04 03:05:55.738553295 +0200
+++ new/usr/src/lib/libm/common/R/__tanf.c	2014-05-04 03:05:55.768109581 +0200
@@ -71,7 +71,7 @@
 
 float
 __k_tanf(double x, int n) {
-	float ft;
+	float ft = 0.0;
 	double z, w;
 	int ix;
 
--- old/usr/src/lib/libm/common/R/cosf.c	2014-05-04 03:05:57.700717690 +0200
+++ new/usr/src/lib/libm/common/R/cosf.c	2014-05-04 03:05:57.927387653 +0200
@@ -76,6 +76,7 @@
 	double	y, z, w;
 	float	f;
 	int	n, ix, hx, hy;
+	volatile int i;
 
 	hx = *((int *)&x);
 	ix = hx & 0x7fffffff;
@@ -85,7 +86,7 @@
 	if (ix <= 0x4016cbe4) {		/* |x| < 3*pi/4 */
 		if (ix <= 0x3f490fdb) {		/* |x| < pi/4 */
 			if (ix <= 0x39800000) {	/* |x| <= 2**-12 */
-				volatile int	i = (int)y;
+				i = (int)y;
 #ifdef lint
 				i = i;
 #endif
--- old/usr/src/lib/libm/common/R/exp10f.c	2014-05-04 03:05:59.335840719 +0200
+++ new/usr/src/lib/libm/common/R/exp10f.c	2014-05-04 03:05:59.153387101 +0200
@@ -31,7 +31,7 @@
 
 #include "libm.h"
 
-double exp10(double);
+extern double exp10(double);
 
 float
 exp10f(float x) {
